// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_geo_msgs:msg/GeoJSON.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_geo_msgs/msg/geo_json.hpp"


#ifndef TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON__TRAITS_HPP_
#define TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_geo_msgs/msg/detail/geo_json__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'features'
#include "tuw_geo_msgs/msg/detail/geo_json_feature__traits.hpp"

namespace tuw_geo_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GeoJSON & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: features
  {
    if (msg.features.size() == 0) {
      out << "features: []";
    } else {
      out << "features: [";
      size_t pending_items = msg.features.size();
      for (auto item : msg.features) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GeoJSON & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: features
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.features.size() == 0) {
      out << "features: []\n";
    } else {
      out << "features:\n";
      for (auto item : msg.features) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GeoJSON & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_geo_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_geo_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_geo_msgs::msg::GeoJSON & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_geo_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_geo_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_geo_msgs::msg::GeoJSON & msg)
{
  return tuw_geo_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_geo_msgs::msg::GeoJSON>()
{
  return "tuw_geo_msgs::msg::GeoJSON";
}

template<>
inline const char * name<tuw_geo_msgs::msg::GeoJSON>()
{
  return "tuw_geo_msgs/msg/GeoJSON";
}

template<>
struct has_fixed_size<tuw_geo_msgs::msg::GeoJSON>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_geo_msgs::msg::GeoJSON>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_geo_msgs::msg::GeoJSON>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON__TRAITS_HPP_
